#!/bin/bash
echo ""
echo $(tput setaf 4)scrip per la creacio de scripts by jordi Hortal V1.3.1
echo scrips de bash, expect o python$(tput sgr 0)
echo ""

if [ $# -eq 0 ]; then
read -p "introdueix el nom de l'script-> " SCRIPT
EXTENSIO=false
elif [ $# -eq 1 ]; then
SCRIPT="$1"
EXTENSIO=false
	if [ "${SCRIPT}" = "$(echo ${SCRIPT} | egrep '\.+')" ]; then
	EXT=$(echo $SCRIPT | cut -d "." -f2)
	SCRIPT=$(echo $SCRIPT | cut -d "." -f1)
	EXTENSIO=true
	fi
elif [ $# -eq 2 ]; then
SCRIPT="$1"
EXT="$2"
EXTENSIO=true
else
echo $(tput setaf 1)Parámetros incorrectos
echo el nom no pot contenir espais buits$(tput sgr 0)
exit 1
fi

while [ "${SCRIPT}" != "$(echo ${SCRIPT} | egrep '^[a-z0-9_.]*$')" ]
do 
echo $(tput setaf 1)nombre no valido: $SCRIPT
echo "No pot contenir caracters. Nomes numeros i/o lletres amb l'excepció de _"
read -p "introdueix el nom de l'script-> $(tput sgr 0)" SCRIPT
EXTENSIO=false
done

ERR=true
if [ $EXTENSIO = "false" ]; then
echo "$(tput setaf 4)Tipus d'Scripts que es poden generar: shell, bash, exp, py"
read -p "especifica llenguatge o extensio de l'script: $(tput sgr 0)" EXT
fi

while [ $ERR != "false" ]
do
case $EXT in
	bash)	EXT="sh"
			RUTA="#!/bin/bash"
			ERR=false
			;;
	expect|.exp|exp) EXT="exp"
			RUTA="#!/usr/bin/expect"
			ERR=false
			;;
	python|.py|py) EXT="py"
			RUTA="#!/usr/bin/python"
			ERR=false
			;;
	.sh|sh) EXT="sh"
			RUTA="#!/bin/bash"
			ERR=false
			;;
	shell)	EXT="sh"
			RUTA="#!/bin/sh"
			ERR=false
			;;		
	*)	echo $(tput setaf 1)extensio/llenguatge no reconeguda
		echo $SCRIPT y $EXT
		read -p "especifica llenguatge o extensio de l'script: $(tput sgr 0)" EXT
		;;
esac
done
cd $HOME && touch $SCRIPT.$EXT && chmod +x $SCRIPT.$EXT
echo $RUTA > $SCRIPT.$EXT && echo '#ENCODING: UTF-8' >> $SCRIPT.$EXT && echo '#Created by Jordi Hortal' >> $SCRIPT.$EXT
echo $(tput setaf 2)script amb nom $SCRIPT.$EXT creat a: $HOME$(tput sgr 0)
sleep 1
geany ./$SCRIPT.$EXT&
exit 0
#ENCODING: UTF-8
#V1.2.1
#add line 17
#v1.3.1
#add option script.py as a name
# $# variable de bash que diu quants arguments hi han (si hi ha alguna cosa despres de la comanda)
# -eq sirve para comparar valores numericos es como un =
#echo -e activa la interpretació de cadenas (ex \n com salt de linia \r retorn de carro
#egrep busca el que li demanis de un string el ^es per negar i el *$ es per indicar que pot apareixer algun cop i que no el tingui en compte
#per seguretat no es pot introduir caracters per si s'escriu per error directament nom.sh
